! By CHRIS ANTONOPOULOS

program BEC_Lyapunov_Exponents
implicit none

real(kind=8),external		:: hamiltonian_function, second_integral
real(kind=8),external		:: derivs, bsstep
real(kind=8),allocatable	:: y(:), initial_condition(:), znorm(:), gsc(:), suma(:), sumkt(:)
real(kind=8),allocatable	:: Lyap_number(:)
real(kind=8),allocatable	:: cc(:)
real(kind=8)			:: t, t0, tf, sum_Lyap_exp
real(kind=8)			:: Lyap_dimension, tol_chaos, acc, gamma, epsilon
real(kind=8)			:: hamiltonianenergy, cc2
real(kind=8)			:: x1, x2, eps, h1, hmin, nok, nbad
real(kind=8)			:: nrg_input, perturbation, c_neighbor
real(kind=8)			:: sum_time_average_kinetic_energy_y1, IcLE, H_KS_entropy
real(kind=4)			:: time_begin
character*(*)			:: file_name_LE
parameter(file_name_LE='BEC_LE')
character(*)			:: filename_input_parameters
parameter(filename_input_parameters='input.in')
integer(kind=4)			:: i, ndof, nn2, NNN, multiple, choosemode, flag, counternrg
integer(kind=4)			:: numfile_info,numfile_Lyap_exps,numfile_LEs_plot_gnu,numfile_IcLE_and_maxdK_dt_vs_nrg,numfile_traj
character(1)			:: char_ndof_1
character(2)			:: char_ndof_2
character(3)			:: char_ndof_3
character(6)			:: char_nrg_1
character(7)			:: char_nrg_2
character(8)			:: char_nrg_3
character(9)			:: char_nrg_4
character(10)			:: char_nrg_5
character(19)			:: char_cc2_1
character(20)			:: char_cc2_2
character(21)			:: char_cc2_3
character(26)			:: arg_nrg, arg_nrg_counter
character(4)			:: char_counternrg
common /param1/ gamma, epsilon
common /param2/ hamiltonianenergy

call cpu_time(time_begin)

!here we read from the command prompt the Hamiltonian energy
!the old way to read from the command prompt
!call getarg(1,arg_nrg)
!call getarg(2,arg_nrg_counter)

!the new way to read from the command prompt
call get_command_argument(1,arg_nrg)
call get_command_argument(2,arg_nrg_counter)

read(arg_nrg,'(f26.16)') nrg_input
read(arg_nrg_counter,'(i4)') counternrg

write(char_counternrg,'(i4)') counternrg

! DO NOT CHANGE THIS VALUE!!!
epsilon=1.d0

call read_input_parameters(perturbation,t0,tf,ndof,numfile_info,numfile_Lyap_exps,filename_input_parameters,numfile_LEs_plot_gnu,numfile_IcLE_and_maxdK_dt_vs_nrg,numfile_traj,gamma,eps,h1,hmin,acc,tol_chaos,choosemode)

t=t0

hamiltonianenergy=nrg_input

call systemqq("mkdir -p results")

open(numfile_IcLE_and_maxdK_dt_vs_nrg,file='IcLE_and_maxdK_dt_vs_nrg.out.'//char_counternrg,status='replace')

! If choosemode=1 then we use the IN PHASE MODE ===> VALID ONLY FOR EVERY ndof
! If choosemode=2 then we use the OUT OF PHASE MODE ===> VALID ONLY FOR ndof EVEN

if (choosemode==1) write(*,'(/,1x,"BEC IPM with periodic boundary conditions",/)')
if (choosemode==2) write(*,'(/,1x,"BEC OPM with periodic boundary conditions",/)')

write(*,'(/,1x,"ndof=",1x,i3)') ndof

!  nn2      .
nn2=2*ndof

!  NNN       : nn2    ..
!    nn2*nn2    nn2xnn2   .
NNN=nn2*nn2+nn2

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

allocate(y(NNN),initial_condition(nn2),znorm(nn2),gsc(nn2),suma(nn2),sumkt(nn2),Lyap_number(nn2))
y=0.d0	;	initial_condition=0.d0	;	znorm=0.d0	;	gsc=0.d0	;	suma=0.d0	;	sumkt=0.d0	;	Lyap_number=0.d0

allocate(cc(2))
cc(1)=0.d0

if (choosemode==1) cc(2)=dsqrt(-cc(1)**2 - 2.d0/gamma + (2.d0*epsilon)/gamma + (2.d0*dsqrt(ndof*(2.d0*hamiltonianenergy*gamma + ndof - 2.d0*epsilon*ndof + epsilon**2*ndof)))/(gamma*ndof))
if (choosemode==2) cc(2)=-dsqrt(-cc(1)**2 - 2.d0/gamma - (2.d0*epsilon)/gamma + (2.d0*dsqrt(ndof*(2.d0*hamiltonianenergy*gamma + ndof + 2.d0*epsilon*ndof + epsilon**2*ndof)))/(gamma*ndof))

!write(*,'(" cc(2)=",f26.16)') cc(2)

if (choosemode==1) then
	do i=1,ndof
		y(i)=cc(1)
	enddo
	do i=ndof+1,nn2
		y(i)=cc(2)
	enddo
endif

if (choosemode==2) then
	do i=1,ndof
		if (mod(i,2)==1) then
			y(i)=cc(1)
		endif
		if (mod(i,2)==0) then
			y(i)=-cc(1)
		endif
	enddo
	c_neighbor=cc(2)+perturbation
	do i=ndof+1,nn2
		if (mod(i,2)==1) then
			y(i)=c_neighbor
		endif

		if (mod(i,2)==0) then
			y(i)=-cc(2)
		endif
	enddo
endif
deallocate(cc)

initial_condition(1:nn2)=y(1:nn2)

do i=1,nn2
	y((nn2+1)*i)=1.d0
enddo

write(*,'(/,1x,"gamma=",1x,f16.10)') gamma
write(*,'(/,1x,"epsilon=",1x,f16.10)') epsilon

hamiltonianenergy=0.d0
hamiltonianenergy=hamiltonian_function(initial_condition,nn2)

write(*,'(/,1x,"Total ENERGY of the BEC Hamiltonian=",1x,f26.16)') hamiltonianenergy
write(*,'(1x,"Second integral value=",1x,f26.16)') second_integral(initial_condition,nn2)

write(*,'(1x,"ABS(BEC Hamiltonian - NRG)=",1x,es13.6)') dabs(hamiltonian_function(y,nn2))
!write(*,'(1x,"Energy per perticle=",1x,f26.16)') hamiltonianenergy/ndof

if ((0.d0<=hamiltonianenergy).and.(hamiltonianenergy<10.d0)) then
	write(char_nrg_1,'(f6.3)') hamiltonianenergy
	if ((1<=ndof).and.(ndof<=9)) then
		write(char_ndof_1,'(i1)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_1,char_nrg_1)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
	endif
	if ((10<=ndof).and.(ndof<=99)) then
		write(char_ndof_2,'(i2)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_2,char_nrg_1)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
	endif
	if ((100<=ndof).and.(ndof<=999)) then
		write(char_ndof_3,'(i3)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_3,char_nrg_1)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
	endif
endif
if ((10.d0<=hamiltonianenergy).and.(hamiltonianenergy<100.d0)) then
	write(char_nrg_2,'(f7.3)') hamiltonianenergy
	if ((1<=ndof).and.(ndof<=9)) then
		write(char_ndof_1,'(i1)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_1,char_nrg_2)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
	endif
	if ((10<=ndof).and.(ndof<=99)) then
		write(char_ndof_2,'(i2)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_2,char_nrg_2)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
	endif
	if ((100<=ndof).and.(ndof<=999)) then
		write(char_ndof_3,'(i3)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_3,char_nrg_2)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
	endif
endif
if ((100.d0<=hamiltonianenergy).and.(hamiltonianenergy<1000.d0)) then
	write(char_nrg_3,'(f8.3)') hamiltonianenergy
	if ((1<=ndof).and.(ndof<=9)) then
		write(char_ndof_1,'(i1)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_1,char_nrg_3)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
	endif
	if ((10<=ndof).and.(ndof<=99)) then
		write(char_ndof_2,'(i2)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_2,char_nrg_3)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
	endif
	if ((100<=ndof).and.(ndof<=999)) then
		write(char_ndof_3,'(i3)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_3,char_nrg_3)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
	endif
endif
if ((1000.d0<=hamiltonianenergy).and.(hamiltonianenergy<10000.d0)) then
	write(char_nrg_4,'(f9.3)') hamiltonianenergy
	if ((1<=ndof).and.(ndof<=9)) then
		write(char_ndof_1,'(i1)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_1//'_nrg='//char_nrg_4//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_1,char_nrg_4)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
	endif
	if ((10<=ndof).and.(ndof<=99)) then
		write(char_ndof_2,'(i2)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_2//'_nrg='//char_nrg_4//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_2,char_nrg_4)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
	endif
	if ((100<=ndof).and.(ndof<=999)) then
		write(char_ndof_3,'(i3)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_3//'_nrg='//char_nrg_4//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_3,char_nrg_4)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
	endif
endif
if ((10000.d0<=hamiltonianenergy).and.(hamiltonianenergy<100000.d0)) then
	write(char_nrg_5,'(f10.3)') hamiltonianenergy
	if ((1<=ndof).and.(ndof<=9)) then
		write(char_ndof_1,'(i1)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_1//'_nrg='//char_nrg_5//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_1,char_nrg_5)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
	endif
	if ((10<=ndof).and.(ndof<=99)) then
		write(char_ndof_2,'(i2)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_2//'_nrg='//char_nrg_5//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_2,char_nrg_5)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
	endif
	if ((100<=ndof).and.(ndof<=999)) then
		write(char_ndof_3,'(i3)') ndof
		open(numfile_info,file=file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
		open(numfile_Lyap_exps,file=file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
		open(numfile_traj,file=file_name_LE//'_trajectory_'//char_ndof_3//'_nrg='//char_nrg_5//'.txt',status='replace')
		call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_3,char_nrg_5)
		call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"'")
		call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
	endif
endif
call write_initial_data(nn2,ndof,NNN,initial_condition,t0,tf,acc,hamiltonianenergy,choosemode,numfile_info)

deallocate(initial_condition)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! here we write the trajectory for Ezequiel to compute the MIR
write(numfile_traj,'(es13.6,2f26.16)') t, y(1), y(ndof)
call flush(numfile_traj)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

sum_time_average_kinetic_energy_y1=0.d0
call odeint(y,NNN,t0,tf,eps,h1,hmin,nok,nbad,derivs,bsstep,acc,nn2,znorm,gsc,suma,sumkt,ndof,flag,hamiltonianenergy,t,numfile_traj,sum_time_average_kinetic_energy_y1,numfile_Lyap_exps,numfile_info)
if (flag==1) goto 1
sum_time_average_kinetic_energy_y1=sum_time_average_kinetic_energy_y1/tf

IcLE=2.d0*sum(sumkt(1:int(ndof/2)))-sum(sumkt(1:ndof))
H_KS_entropy=sum(sumkt(1:ndof))

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
write(numfile_IcLE_and_maxdK_dt_vs_nrg,'(es13.6,6f26.16,i4)') t, hamiltonianenergy, IcLE, H_KS_entropy, sumkt(1), sumkt(1)-sumkt(2), sum_time_average_kinetic_energy_y1, counternrg
call flush(numfile_IcLE_and_maxdK_dt_vs_nrg)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

close(numfile_IcLE_and_maxdK_dt_vs_nrg)

if ((0.d0<=hamiltonianenergy).and.(hamiltonianenergy<10.d0)) then
	write(char_nrg_1,'(f6.3)') hamiltonianenergy
	if ((1<=ndof).and.(ndof<=9)) then
		write(char_ndof_1,'(i1)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_1//'_nrg='//char_nrg_1//".gnu' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
		call systemqq("cd 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'; gnuplot < 'LEs_plot_"//char_ndof_1//"_nrg="//char_nrg_1//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
	if ((10<=ndof).and.(ndof<=99)) then
		write(char_ndof_2,'(i2)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_2//'_nrg='//char_nrg_1//".gnu' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
		call systemqq("cd 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'; gnuplot < 'LEs_plot_"//char_ndof_2//"_nrg="//char_nrg_1//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
	if ((100<=ndof).and.(ndof<=999)) then
		write(char_ndof_3,'(i3)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_3//'_nrg='//char_nrg_1//".gnu' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
		call systemqq("cd 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'; gnuplot < 'LEs_plot_"//char_ndof_3//"_nrg="//char_nrg_1//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
endif
if ((10.d0<=hamiltonianenergy).and.(hamiltonianenergy<100.d0)) then
	write(char_nrg_2,'(f7.3)') hamiltonianenergy
	if ((1<=ndof).and.(ndof<=9)) then
		write(char_ndof_1,'(i1)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_1//'_nrg='//char_nrg_2//".gnu' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
		call systemqq("cd 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'; gnuplot < 'LEs_plot_"//char_ndof_1//"_nrg="//char_nrg_2//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
	if ((10<=ndof).and.(ndof<=99)) then
		write(char_ndof_2,'(i2)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_2//'_nrg='//char_nrg_2//".gnu' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
		call systemqq("cd 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'; gnuplot < 'LEs_plot_"//char_ndof_2//"_nrg="//char_nrg_2//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
	if ((100<=ndof).and.(ndof<=999)) then
		write(char_ndof_3,'(i3)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_3//'_nrg='//char_nrg_2//".gnu' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
		call systemqq("cd 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'; gnuplot < 'LEs_plot_"//char_ndof_3//"_nrg="//char_nrg_2//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
endif
if ((100.d0<=hamiltonianenergy).and.(hamiltonianenergy<1000.d0)) then
	write(char_nrg_3,'(f8.3)') hamiltonianenergy
	if ((1<=ndof).and.(ndof<=9)) then
		write(char_ndof_1,'(i1)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_1//'_nrg='//char_nrg_3//".gnu' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
		call systemqq("cd 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'; gnuplot < 'LEs_plot_"//char_ndof_1//"_nrg="//char_nrg_3//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
	if ((10<=ndof).and.(ndof<=99)) then
		write(char_ndof_2,'(i2)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_2//'_nrg='//char_nrg_3//".gnu' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
		call systemqq("cd 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'; gnuplot < 'LEs_plot_"//char_ndof_2//"_nrg="//char_nrg_3//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
	if ((100<=ndof).and.(ndof<=999)) then
		write(char_ndof_3,'(i3)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_3//'_nrg='//char_nrg_3//".gnu' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
		call systemqq("cd 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'; gnuplot < 'LEs_plot_"//char_ndof_3//"_nrg="//char_nrg_3//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
endif
if ((1000.d0<=hamiltonianenergy).and.(hamiltonianenergy<10000.d0)) then
	write(char_nrg_4,'(f9.3)') hamiltonianenergy
	if ((1<=ndof).and.(ndof<=9)) then
		write(char_ndof_1,'(i1)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_1//'_nrg='//char_nrg_4//".gnu' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_1//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'")
		call systemqq("cd 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_4//"'; gnuplot < 'LEs_plot_"//char_ndof_1//"_nrg="//char_nrg_4//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
	if ((10<=ndof).and.(ndof<=99)) then
		write(char_ndof_2,'(i2)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_2//'_nrg='//char_nrg_4//".gnu' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_2//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'")
		call systemqq("cd 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_4//"'; gnuplot < 'LEs_plot_"//char_ndof_2//"_nrg="//char_nrg_4//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
	if ((100<=ndof).and.(ndof<=999)) then
		write(char_ndof_3,'(i3)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_3//'_nrg='//char_nrg_4//".gnu' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_3//'_nrg='//char_nrg_4//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'")
		call systemqq("cd 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_4//"'; gnuplot < 'LEs_plot_"//char_ndof_3//"_nrg="//char_nrg_4//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
endif
if ((10000.d0<=hamiltonianenergy).and.(hamiltonianenergy<100000.d0)) then
	write(char_nrg_5,'(f10.3)') hamiltonianenergy
	if ((1<=ndof).and.(ndof<=9)) then
		write(char_ndof_1,'(i1)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_1//'_nrg='//char_nrg_5//".gnu' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_1//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'")
		call systemqq("cd 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_5//"'; gnuplot < 'LEs_plot_"//char_ndof_1//"_nrg="//char_nrg_5//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
	if ((10<=ndof).and.(ndof<=99)) then
		write(char_ndof_2,'(i2)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_2//'_nrg='//char_nrg_5//".gnu' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_2//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'")
		call systemqq("cd 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_5//"'; gnuplot < 'LEs_plot_"//char_ndof_2//"_nrg="//char_nrg_5//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
	if ((100<=ndof).and.(ndof<=999)) then
		write(char_ndof_3,'(i3)') ndof
		call systemqq("mv '"//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
		call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
		call systemqq("mv 'LEs_plot_"//char_ndof_3//'_nrg='//char_nrg_5//".gnu' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
		call systemqq("mv '"//file_name_LE//"_trajectory_"//char_ndof_3//'_nrg='//char_nrg_5//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
		call systemqq("cp 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"'")
		call systemqq("mv 'IcLE_and_maxdK_dt_vs_nrg.out."//char_counternrg//"' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'")
		call systemqq("cd 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_5//"'; gnuplot < 'LEs_plot_"//char_ndof_3//"_nrg="//char_nrg_5//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
	endif
endif

if (t>=tf) then
	write(numfile_Lyap_exps,'(f26.16,1x,<nn2>f26.16)') t,(sumkt(i),i=1,nn2)
	call flush(numfile_Lyap_exps)
endif
close(numfile_Lyap_exps)
close(numfile_traj)

call write_Lyap_exponents(nn2,sumkt,t,numfile_info)
call sum_Lyap_exponents(nn2,sumkt,sum_Lyap_exp)
call write_sum_Lyap_exponents(sum_Lyap_exp,t,numfile_info)
call Lyapunov_Numbers(nn2,sumkt,Lyap_number)
call write_Lyap_numbers(nn2,Lyap_number,t,numfile_info)
call Lyapunov_Dimension(nn2,sumkt,Lyap_dimension)
call write_Lyap_Dimension(Lyap_Dimension,t,numfile_info)
call classification_of_the_type_of_attractor(nn2,sumkt,tol_chaos,numfile_info)
call write_used_time(time_begin,numfile_info)
call chaos_or_integrability(nn2,sumkt,tol_chaos,numfile_info)

1 continue
call write_my_name(numfile_info)

deallocate(y,znorm,gsc,suma,sumkt,Lyap_number)

end program BEC_Lyapunov_Exponents
